import QtQuick 2.2
import MuseScore 1.0
import FileIO 1.0
import QtQuick.Controls 1.0
import QtQuick.Dialogs 1.0
import QtQuick.Layouts 1.1

MuseScore {
  menuPath: "Plugins.writeReadSeettingsDemo"
  version: "2.0"
  description: qsTr("This plugin Write and Read the setting of plugin")
  pluginType: "dialog"

  id: window
  width:200
  height:100
  ExclusiveGroup { id: exclusiveGroupKey }

  property var comboBoxInitValue : 0

  RowLayout {
    id: column
    x : 10
    y : 10
    Label {
      font.pointSize: 14
      text: "Select" 
    }
  }

  RowLayout {
    x : 60
    y : 10
    ComboBox {
      currentIndex: comboBoxInitValue     //      doesn't work
      model: ListModel {
        id: chooseList
        property var key
        ListElement { text: "choose A"; fName: 0 }
        ListElement { text: "choose B"; fName: 1 }
        ListElement { text: "choose C"; fName: 2 }
      }
      width: 100
      onCurrentIndexChanged: {
        console.debug(chooseList.get(currentIndex).text + ", " +chooseList.get(currentIndex).fName)
        chooseList.key = chooseList.get(currentIndex).fName
        console.debug(chooseList.key)
      }
    } // end ComboBox
  }

  RowLayout {
    x : 50
    y : 60
    Button {
      id: closeButton
      text: "Close"
      onClicked: { Qt.quit() }
    }
    Button {
      id: okButton
      text: "Ok"
      onClicked: {
        apply()
        Qt.quit()
      }
    }
  }


  function apply() {
    curScore.startCmd()
    my_file1.write(chooseList.key);
    curScore.endCmd()           
  }


  onRun: {
    var fileContents = my_file1.read();
    console.log("Read from file value="+ Number(fileContents[0]));
    comboBoxInitValue =Number(fileContents[0])

    console.log("tempPath(): " + my_file1.tempPath() );

    if (typeof curScore === 'undefined')   Qt.quit();
  }


  FileIO {
    id: my_file1
    source: tempPath() + "/temp9999.txt"      // OK 
//   source: "/Users/tac/Documents/temp9999.txt"    // OK
//    source: "temp9999.txt"  //  no
//    source: "./temp9999.txt"  //  no
//    source: "$HOME/temp9999.txt"  //  no
    onError: console.log(msg)
  }
}
